#include <zmq_bind.mqh>
#include <commando_utils.mqh>
#include <commando_process.mqh>

//extern string type = "ALL";
extern string pub_address = "tcp://127.0.0.1:5050";
extern string server_address = "tcp://127.0.0.1:5052";

string id = "";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
  ObjectCreate("commando_label", OBJ_LABEL, 0, 0, 0);
  ObjectSet("commando_label", OBJPROP_XDISTANCE, 2);
  ObjectSet("commando_label", OBJPROP_YDISTANCE, 10);
  ObjectSetText("commando_label", "COMMANDO alpha 0", 10, "Times New Roman", Blue);
  WindowRedraw();
  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int client,server, pub;
int poll;
int context;

int deinit()
{
  z_close(pub);
  z_close(server);
  z_term(context);
  ObjectDelete("commando_label");
  WindowRedraw();
  return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start() 
{
  Print("using zeromq version "+z_version_string());
  
  id = AccountServer()+" "+AccountNumber();
  Print("ID is "+id);
 
  context = z_init(1);
  pub = z_socket(context,ZMQ_PUB);
  if (z_bind(pub,pub_address)==-1) {
    Print("Failed to bind to pub address "+pub_address);
    return(-1);
  }
  server = z_socket(context,ZMQ_REP);
  if (z_bind(server,server_address)==-1) {
    Print("Failed to bind to server address "+server_address);
    return(-1);
  }
  
  poll = z_new_poll(server);
  
  while (IsStopped()==false) {
    z_send(pub,id,ZMQ_SNDMORE);
    z_send(pub,server_address,ZMQ_NOBLOCK);
    if (z_poll(poll,500)>0) {
      string message[]; 
      z_recv_multi(server,message);
      if (message[0]==id) { 
        string request[];
        split(request,message[1]);
        process(server,request);
      } else {
        //what do we do if we receive wrong thing!??
        z_send(server,"",ZMQ_NOBLOCK);
      }
    }
   }
     
  Print("Stopping ...");
  return(0); 
}
//+------------------------------------------------------------------+

